#include "stdafx.h"
#include "Pgm11a.h"
#include "GameFrame.h"
#include "PlayerView.h"
#include "OtherView.h"
#include "GameDoc.h"
#include "resource.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_DYNCREATE(GameFrame, CMDIChildWnd)

GameFrame::GameFrame() { }
GameFrame::~GameFrame() { }

/***************************************************************************/
/*                                                                         */
/* PreCreateWindow: remove FWS_ADDTOTITLE so template name is used         */
/*                  not document file name                                 */
/*                                                                         */
/***************************************************************************/

BOOL      GameFrame::PreCreateWindow (CREATESTRUCT &cs) {
 cs.style &= ~(LONG) FWS_ADDTOTITLE;
 return CMDIChildWnd::PreCreateWindow (cs);
}

BEGIN_MESSAGE_MAP(GameFrame, CMDIChildWnd)
 ON_WM_CLOSE ()
END_MESSAGE_MAP()

/***************************************************************************/
/*                                                                         */
/* OnClose: query user only for closing player views                       */
/*                                                                         */
/***************************************************************************/

void      GameFrame::OnClose () {
 CString msg1, msg2;
 CView *ptrview = GetActiveView ();
 CView *ptrcview;
 if (ptrview && ptrview->IsKindOf (RUNTIME_CLASS (PlayerView))) {
  msg1.LoadString (IDS_PLAYER_QUIT);
  msg2.LoadString (IDS_PLAYER_QUITMSG);
  if (MessageBox (msg2, msg1, MB_YESNO | MB_ICONQUESTION) == IDYES) {
   GameDoc *ptrdoc = ((PlayerView*) ptrview)->GetDocument ();
   if (ptrdoc && ptrdoc->IsKindOf (RUNTIME_CLASS (GameDoc)))
    ptrdoc->LogoffPlayer ();
   POSITION pos = ptrdoc->GetFirstViewPosition ();
   while (pos != NULL) {
    ptrcview = ptrdoc->GetNextView (pos);
    if (ptrcview != ptrview)
     ptrcview->GetParentFrame ()->PostMessage (WM_CLOSE, 0, 0L);
   }
   CMDIChildWnd::OnClose ();
  }
 }
 else if (ptrview && ptrview->IsKindOf (RUNTIME_CLASS (OtherView))) {
   GameDoc *ptrdoc = ((OtherView*) ptrview)->GetDocument ();
   if (ptrdoc && ptrdoc->IsKindOf (RUNTIME_CLASS (GameDoc)))
    ptrdoc->LogoffOther ();
   CMDIChildWnd::OnClose ();
  }
else CMDIChildWnd::OnClose ();
}

#ifdef _DEBUG
void GameFrame::AssertValid () const { CMDIChildWnd::AssertValid (); }
void GameFrame::Dump (CDumpContext &dc) const { CMDIChildWnd::Dump (dc); }
#endif
