#include "stdafx.h"
#include "Pgm11a.h"
#include "HeadData.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_SERIAL (HeadData, CObject, 0)
IMPLEMENT_SERIAL (HeadDataArray, CObArray, 0)

HeadData::HeadData() { }
HeadData::~HeadData() { }

/***************************************************************************/
/*                                                                         */
/* HeaderData: copy constructor                                            */
/*                                                                         */
/***************************************************************************/

HeadData::HeadData (char *dname, char *fname, long st, ControlDoc *ptrdoc) {
 strcpy_s (battle_descr, sizeof(battle_descr), dname);
 strcpy_s (battle_basefile, sizeof(battle_basefile), fname);
 strcpy_s (battle_file, sizeof(battle_file), theApp.mainpath);
 strcat_s (battle_file, sizeof(battle_file), fname);
 battle_status = st;
 ptrctldoc = ptrdoc;
}

/***************************************************************************/
/*                                                                         */
/* Serialize: attempt to I/O the bth file                                  */
/*                                                                         */
/***************************************************************************/

void HeadData::Serialize(CArchive& ar) {
 CObject::Serialize (ar);
 long i, j;
 BYTE b;
 if (ar.IsStoring ()) {
  j = strlen (battle_descr);
  ar << j;
  for (i=0; i<j; i++) ar << (BYTE) battle_descr[i];
  j = strlen (battle_basefile);
  ar << j;
  for (i=0; i<j; i++) ar << (BYTE) battle_basefile[i];
  ar << battle_status;
 }
 else {
  ar >> j;
  for (i=0; i<j; i++) {
   ar >> b;
   battle_descr[i] = b;
  }
  battle_descr[j] = 0;
  ar >> j;
  for (i=0; i<j; i++) {
   ar >> b;
   battle_basefile[i] = b;
  }
  battle_basefile[j] = 0;
  ar >> battle_status;
  strcpy_s (battle_file, sizeof(battle_file), theApp.mainpath);
  strcat_s(battle_file, sizeof(battle_file), battle_basefile);
  ptrctldoc = NULL;
 }
}

/***************************************************************************/
/*                                                                         */
/* Read: input text version of bth file                                    */
/*                                                                         */
/***************************************************************************/

BOOL HeadData::Read (CFile &file) {
 int i, count;
 char c;
 i=0;
 count = 1;
 while (count) { // read all file bytes, checking for new line codes
  count = file.Read (&battle_descr[i], 1);   // reads one byte
  if (!count) battle_descr[i] = 0;
  else if (battle_descr[i] == 0x0d) {
   battle_descr[i] = 0;
   file.Read (&c, 1);
   break;
  }
  i++;
 }
 if (!count) return FALSE;

 i=0;
 while (count) { // read all file bytes, checking for new line codes
  count = file.Read (&battle_basefile[i], 1);   // reads one byte
  if (!count) battle_basefile[i] = 0;
  else if (battle_basefile[i] == 0x0d) {
   battle_basefile[i] = 0;
   file.Read (&c, 1);
   break;
  }
  i++;
 }
 strcpy_s (battle_file, sizeof(battle_file), theApp.mainpath);
 strcat_s (battle_file, sizeof(battle_file), battle_basefile);
 if (!count) return FALSE;

 char s[80];
 i=0;
 while (count) { // read all file bytes, checking for new line codes
  count = file.Read (&s[i], 1);   // reads one byte
  if (!count) s[i] = 0;
  else if (s[i] == 0x0d) {
   s[i]=0;
   file.Read (&c, 1);
   break;
  }
  i++;
 }
 battle_status = atol (s);

 ptrctldoc = NULL;

 return TRUE;
}

#ifdef _DEBUG
void HeadData::AssertValid() const { CObject::AssertValid(); }
void HeadData::Dump(CDumpContext& dc) const { CObject::Dump(dc); }
#endif //_DEBUG
