#pragma once
#include <fstream>
using namespace std;

class ControlDoc;

/***************************************************************************/
/*                                                                         */
/* HeadData: overall battle information class                              */
/*                                                                         */
/***************************************************************************/

#define Battle_NotStarted  0
#define Battle_InProgress  1
#define Battle_Completed   2

class HeadData : public CObject {
public:
	HeadData();           // constructor used by dynamic creation
 HeadData (char*, char*, long, ControlDoc*); // copy constr
	DECLARE_SERIAL(HeadData)

char          battle_descr [MAX_PATH];  // user description of battle
char          battle_file  [MAX_PATH];  // filename of battle data
char          battle_basefile [MAX_PATH];
long          battle_status;            // current battle status 
ControlDoc   *ptrctldoc;                // will hold a ControlDoc ptr

virtual void Serialize(CArchive& ar);
virtual     ~HeadData();
virtual BOOL Read (CFile&);

protected:
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif
};

/***************************************************************************/
/*                                                                         */
/* HeaderDataArray: array container for header data objects                */
/*                                                                         */
/***************************************************************************/

class HeadDataArray : public CObArray {
	DECLARE_SERIAL(HeadDataArray)
public:
        HeadDataArray () {}       // constructor for serialization
};
