#pragma once
class HeadView;
class HeadDataArray;
class HeadData;

/***************************************************************************/
/*                                                                         */
/* HeadDoc: Class to maintain lists of current battle to do                */
/*                                                                         */
/***************************************************************************/

class HeadDoc : public CDocument {

public:
HeadDataArray  battle_array; // container of list of battle header objs
long           selection;    // currently selected header data

protected: // create from serialization only
	HeadDoc();
	DECLARE_DYNCREATE(HeadDoc)

public:
	virtual BOOL  OnNewDocument();
	virtual void  Serialize(CArchive& ar);
	virtual BOOL  CanCloseFrame(CFrameWnd* pFrame);
	virtual void  DeleteContents();
	virtual void  OnCloseDocument();
	virtual BOOL  OnOpenDocument(LPCTSTR lpszPathName);
	virtual      ~HeadDoc();
         long  GetNumBattles (); // gets number of battle header data objs
         void  GetThisBattle (char*, char*, char*, char*, long*, long*);
         void  LogoffBattle (long);
         void  LogoffAllBattles ();
    HeadView*  GetHeadView ();
afx_msg  void  OnFileClose ();
afx_msg  void  CmNextBattle ();
afx_msg  void  CmPrevBattle ();
afx_msg  void  CmActivateBattle ();
afx_msg  void  CmCloseBattle ();
afx_msg  void  CmEnableNextBattle (CCmdUI*);
afx_msg  void  CmEnablePrevBattle (CCmdUI*);
afx_msg  void  CmEnableActivateBattle (CCmdUI*);
afx_msg  void  CmEnableCloseBattle (CCmdUI*);

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif
	DECLARE_MESSAGE_MAP()
};
