#include "stdafx.h"
#include "Pgm11a.h"
#include "OtherView.h"
#include "resource.h"           // pick up resource id numbers
#include "GameDoc.h"        // access to the doc

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_DYNCREATE(OtherView, GameView)

OtherView::OtherView() : GameView () {
 playerid = -1; // indicate no player installed yet
}

OtherView::~OtherView() { }

BEGIN_MESSAGE_MAP(OtherView, GameView)
END_MESSAGE_MAP()

/***************************************************************************/
/*                                                                         */
/* OnInitialUpdate: set the initial size of the view                       */
/*                                                                         */
/***************************************************************************/

void      OtherView::OnInitialUpdate () {
 GameDoc *ptrdoc = GetDocument ();
 ptrdoc->LoginOtherView (this, playerid);
 ptrpalette = ptrdoc->GetWorldSizeAndPalette (world_size);
 GameView::OnInitialUpdate ();
 CreateOffScreenBuffer (); // let base handle errors
}

/***************************************************************************/
/*                                                                         */
/* OnUpdate: Process hints from document                                   */
/*                                                                         */
/***************************************************************************/

void      OtherView::OnUpdate(CView *ptrsender, LPARAM lhint,
                              CObject* /*ptrhint*/) {

 ASSERT(ptrsender != this);               // avoid if its us
 if (lhint == 0) Invalidate (TRUE);       // force repaint, erase background
 else if (lhint == 1) Invalidate (FALSE); // force repaint, no erase on scroll
}

/***************************************************************************/
/*                                                                         */
/* Draw:                                                                   */
/*                                                                         */
/***************************************************************************/

void      OtherView::Draw (CDC *ptrdc) {
 if (!ptroffscreenDC) return;

 CRect drawrect = offscreen_rect;
 CRect cliprect;
 ptrdc->GetClipBox (cliprect);

 CPalette *ptroldpal = NULL;
 if (ptrpalette) {
  ptroldpal = ptrdc->SelectPalette (ptrpalette->GetPalette (), FALSE);
  ptrdc->RealizePalette ();
 }
 BitBlt (ptrdc->GetSafeHdc (), drawrect.left, drawrect.top, drawrect.Width(),
         drawrect.Height (), ptroffscreenDC->hbmpdc, drawrect.left,
         drawrect.top, SRCCOPY);
 if (ptroldpal) ptrdc->SelectPalette (ptroldpal, 0);
}

/***************************************************************************/
/*                                                                         */
/* Render:                                                                 */
/*                                                                         */
/***************************************************************************/

void      OtherView::Render (CRect*) {
 GameDoc *ptrdoc = GetDocument ();
 BitmapDC *ptrmemdc = ptrdoc->GetWorldDC ();
 if (!ptrmemdc || !ptroffscreenDC) return;
 BitBlt (ptroffscreenDC->hbmpdc, 0, 0, offscreen_rect.Width (),
         offscreen_rect.Height (), ptrmemdc->hbmpdc, offscreen_offset.x,
         offscreen_offset.y, SRCCOPY);
}

/***************************************************************************/
/*                                                                         */
/* OnDraw:                                                                 */
/*                                                                         */
/***************************************************************************/

void      OtherView::OnDraw (CDC *ptrdc) {
 Render ();
 Draw (ptrdc);
}

#ifdef _DEBUG
void OtherView::AssertValid() const { GameView::AssertValid(); } 
void OtherView::Dump(CDumpContext& dc) const { GameView::Dump(dc); }
#endif //_DEBUG
