#include "stdafx.h"
#include "Pgm14c.h"
#include "StopButtons.h"

IMPLEMENT_DYNAMIC(StopButtons, CButton)

StopButtons::StopButtons() {
 ptrbr = NULL;
 checked = false;
}

StopButtons::~StopButtons() {
 if (ptrbr) delete ptrbr;
}

BEGIN_MESSAGE_MAP(StopButtons, CButton)
END_MESSAGE_MAP()


void StopButtons::SetColor (int i) {
 if (ptrbr) return;
 // make the colored brush
 if (i == 0) ptrbr = new CBrush (RGB(255,0,0));
 else if (i==1) ptrbr = new CBrush (RGB(255,255,0));
 else ptrbr = new CBrush (RGB(0,255,0));
}

bool StopButtons::GetChecked () const {
 return checked;
}

void StopButtons::SetChecked (bool ck) {
  checked = ck;
}

void StopButtons::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct) {
 // get the dc given to us in the parameter structure
 CDC* pDC = CDC::FromHandle(lpDrawItemStruct->hDC);

 // get height, but not larger than 14 pixels
 int h = lpDrawItemStruct->rcItem.bottom - lpDrawItemStruct->rcItem.top;
 h = h>14 ? 14 : h;

 CRect r; // our drawing rectangle, based on where we are to draw image
 r.SetRect (lpDrawItemStruct->rcItem.left,lpDrawItemStruct->rcItem.top, h, h);
 CBrush *ptroldbr;

 // commented are possible drawing states, here I only want whether or
 // not the button is checked right now
	if (//(lpDrawItemStruct->itemState & ODS_SELECTED) != 0 ||
     //(lpDrawItemStruct->itemState & ODS_DEFAULT) != 0 || 
     //(lpDrawItemStruct->itemState & ODS_FOCUS) != 0 ||
     //(lpDrawItemStruct->itemState & ODS_CHECKED) != 0 ){
     checked)		{
  // draw with colored center circle
  ptroldbr =  (CBrush*) pDC->SelectStockObject (BLACK_BRUSH);
  pDC->Ellipse (&r);
  r.InflateRect (-1, -1);
  pDC->SelectStockObject (LTGRAY_BRUSH);
  pDC->Ellipse (&r);
  r.InflateRect (-2, -2);
  pDC->SelectObject (ptrbr);
  pDC->Ellipse (&r);
  pDC->SelectObject (ptroldbr);
 }
 else {
  // draw with grey center brush
  ptroldbr =  (CBrush*) pDC->SelectStockObject (BLACK_BRUSH);
  pDC->Ellipse (&r);
  r.InflateRect (-1, -1);
  pDC->SelectStockObject (LTGRAY_BRUSH);
  pDC->Ellipse (&r);
  r.InflateRect (-2, -2);
  pDC->SelectObject (ptroldbr);
 }

 // here, draw any focus rectangle needed when tabbing
 if ((lpDrawItemStruct->itemState & ODS_FOCUS) != 0 ) {
  r.InflateRect (3, 3);
  pDC->DrawFocusRect (&r);
 }
}

int StopButtons::CompareItem(LPCOMPAREITEMSTRUCT lpCompareItemStruct) {
 return 0;
}

void StopButtons::MeasureItem(LPMEASUREITEMSTRUCT lpMeasureItemStruct) {
}

