#include "stdafx.h"
#include "Pgm14c.h"
#include "StopLightDlg.h"

IMPLEMENT_DYNAMIC(StopLightDlg, CDialog)

StopLightDlg::StopLightDlg(CWnd* pParent /*=NULL*/)
	: CDialog(StopLightDlg::IDD, pParent)
 , which_is_on(0), which_is_on2 (0) { }

StopLightDlg::~StopLightDlg() { }

void StopLightDlg::DoDataExchange(CDataExchange* pDX) {
 CDialog::DoDataExchange(pDX);
 // fancy method: obtain the hidden control to be replaced by fancy window
 DDX_Control(pDX, IDC_BUTTONWINDOW, tobereplaced);
}

BEGIN_MESSAGE_MAP(StopLightDlg, CDialog)
 ON_BN_CLICKED(IDC_RADIO1, &StopLightDlg::OnRedButtonClick)
 ON_BN_CLICKED(IDC_RADIO2, &StopLightDlg::OnYellowButtonClick)
 ON_BN_CLICKED(IDC_RADIO3, &StopLightDlg::OnGreenButtonClick)
END_MESSAGE_MAP()


BOOL StopLightDlg::OnInitDialog() {
	CDialog::OnInitDialog();
	// crude method: subclass three radio buttons to our class
	if (!red.SubclassDlgItem(IDC_RADIO1, this) ||
     !yellow.SubclassDlgItem(IDC_RADIO2, this) ||
     !green.SubclassDlgItem(IDC_RADIO3, this)) {
		EndDialog(IDCANCEL);
		return FALSE;
	}
 // now set initial values for the crude method
	red.SetColor (0);
 yellow.SetColor (1);
 green.SetColor (2);
 MaintainRedYellowGreenChecks ();

 // fancy method: create the rygWindow and position it over the hidden
 // dummy button window
 CRect rect;
 tobereplaced.GetClientRect (&rect);
 tobereplaced.MapWindowPoints (this, &rect);
  // create a child view to occupy the client area of the frame
 if (!rygWindow.Create (NULL, NULL, AFX_WS_DEFAULT_VIEW | WS_TABSTOP,
  CRect(0, 0, 0, 0), this, AFX_IDW_PANE_FIRST, NULL)) {
  return -1;
 }
 rygWindow.SetWindowPos (0, rect.left, rect.top, rect.Width(), rect.Height (), SWP_NOZORDER);
 // set its text and which button is on
 rygWindow.SetText ("Account approaching limit?");
 rygWindow.SetChecked (which_is_on2);

 return TRUE;
}

void StopLightDlg::OnOK() {
 UpdateData (true);

 which_is_on2 = rygWindow.GetChecked (); // fancy method: get which button

 // crude method: get which button is on
 if (red.GetChecked ()) {
  which_is_on = 0;
 }
 else if (yellow.GetChecked ()) {
  which_is_on = 1;
 }
 else {
  which_is_on = 2;
 }
 CDialog::OnOK();
}

// crude method: get which button was clicked and adjust all buttons
void StopLightDlg::OnRedButtonClick() {
 which_is_on = 0;
 MaintainRedYellowGreenChecks ();
}

void StopLightDlg::OnYellowButtonClick() {
 which_is_on = 1;
 MaintainRedYellowGreenChecks ();
}

void StopLightDlg::OnGreenButtonClick() {
 which_is_on = 2;
 MaintainRedYellowGreenChecks ();
}

void StopLightDlg::MaintainRedYellowGreenChecks () {
 if (which_is_on == 0) {
  red.SetChecked (true);
  yellow.SetChecked ();
  green.SetChecked ();
 }
 else if (which_is_on == 1) {
  red.SetChecked ();
  yellow.SetChecked (true);
  green.SetChecked ();
 }
 else if (which_is_on == 2) {
  red.SetChecked ();
  yellow.SetChecked ();
  green.SetChecked (true);
 }
 else 
  return;
 red.Invalidate ();
 yellow.Invalidate ();
 green.Invalidate ();
}

// for fancy method, handle tabbing into that window
// want only tab key and only if green button above the
// fancy window was last tabbed to...
BOOL StopLightDlg::PreTranslateMessage(MSG* pMsg) {
 if (pMsg->message == WM_KEYDOWN && pMsg->wParam == VK_TAB &&
     green.GetState () & 0x0008) {
  // pass tab to fancy window
  rygWindow.SendMessage (WM_CHAR, VK_TAB, 42);
  // see if it still has the focus. If not, pass on to the
  // next dialog control
  if (rygWindow.StillHasFocus ())
   return TRUE;
 }
 return CDialog::PreTranslateMessage(pMsg);
}
