#pragma once

struct FONTITEM {
 LOGFONT lf;
 BOOL    ttFont;
};

/***************************************************************************/
/*                                                                         */
/* FontEnumDlg Class Definition                                            */
/*                                                                         */
/***************************************************************************/

class FontEnumDlg : public CDialog {

 /***************************************************************************/
 /*                                                                         */
 /* Class Data Members                                                      */
 /*                                                                         */
 /***************************************************************************/

protected:

LOGFONT    *ptrlf;        // the transfer LOGFONT buffer

CImageList  bmplist;      // bmp images for list view
CPtrArray   fonts_array;  // the array of font items
CListCtrl  *ptrlistview;  // handy ptr to the list view control

 /***************************************************************************/
 /*                                                                         */
/* Functions:                                                              */
 /*                                                                         */
 /***************************************************************************/

public:

              FontEnumDlg (CWnd*, LOGFONT*); // constructor save xfer buffer
             ~FontEnumDlg ();                // remove array of fonts

// call back font enumeration function
static BOOL CALLBACK AFX_EXPORT  EnumPrinterFonts (ENUMLOGFONT*,
                                              NEWTEXTMETRICEX*, int, LPVOID);

protected:

        void  BuildFontList (CDC*);          // enum fonts and build array
        void  AddFontsToList ();             // add array of fonts to list view
afx_msg void  OnItemSelected (NMHDR*, LRESULT*); // return selection to user
afx_msg BOOL  OnInitDialog ();               // setup list view - do font enum

DECLARE_MESSAGE_MAP()
};
