#pragma once

/***************************************************************************/
/*                                                                         */
/* FrameWin Class Definition                                               */
/*                                                                         */
/***************************************************************************/

class FrameWin : public CFrameWnd {

 /***************************************************************************/
 /*                                                                         */
 /* Class Data Members                                                      */
 /*                                                                         */
 /***************************************************************************/

protected:

LOGFONT *ptrlogfont;         // user selected font from the common dialog box
CEdit   *ptreditwin;         // pointer to our CEdit main window

char     filename[MAX_PATH]; // full path file spec
char     sfilename[14];      // filename.extension
HFONT    hfont;              // font copy for the CEdit window

 /***************************************************************************/
 /*                                                                         */
 /* Class Functions:                                                        */
 /*                                                                         */
 /***************************************************************************/

public:
              FrameWin (CWnd*, const char*); // constructor

protected:

afx_msg int   OnCreate (LPCREATESTRUCT);     // construct CEdit control
afx_msg void  OnClose ();                    // determines if app can quit yet
afx_msg void  OnSize (UINT, int, int);       // position CEdit control
afx_msg void  OnDestroy ();                  // remove CEdit control & logfont
afx_msg void  OnRButtonDown (UINT, CPoint);  // popup edit menu

// utility functions
int           DisplayMsg (int, int, UINT);   // displays a message box
void          SaveCheck ();                  // query user about saving file
void          SaveFile ();                   // save the file
void          UpdateCaption ();              // put filename into title bar

// command processors
afx_msg void  CmExit ();                     // post a quit message
afx_msg void  CmEnumFont ();                 // Choose Font by Enumeration
afx_msg void  CmFontChange ();               // Choose Font Common Dialog
afx_msg void  CmFileNew ();                  // start a new file
afx_msg void  CmFileOpen ();                 // open existing file
afx_msg void  CmFileSave ();                 // save the file with same name
afx_msg void  CmFileSaveAs ();               // save with new name
afx_msg void  CmEditUndo ();                 // undo last change
afx_msg void  CmEditCut ();                  // cut to clipboard
afx_msg void  CmEditCopy ();                 // copy to clipboard
afx_msg void  CmEditPaste ();                // paste from the clipboard
afx_msg void  CmEditClear ();                // clear text
afx_msg void  CmHelpAbout ();                // help about our app
afx_msg void  CmEnableHaveFile (CCmdUI*);    // common menu enabler

DECLARE_MESSAGE_MAP()
};
