#pragma once

class LogfontDlg; // forward reference

/***************************************************************************/
/*                                                                         */
/* FrameWin Class Definition                                               */
/*                                                                         */
/***************************************************************************/

class FrameWin : public CFrameWnd {

 /***************************************************************************/
 /*                                                                         */
 /* Class Data Members                                                      */
 /*                                                                         */
 /***************************************************************************/

public:

                      // the real transfer buffers for the dialog
LOGFONT    lf;        // the current logfont - reset by the dialog
TEXTMETRIC tm;        // the current text metrics of the matched font
BOOL       isprinter; // indicator on which DC to map font - TRUE for printer

protected:

int         avg_caps_width;   // average capital letter width
int         avg_char_width;   // average character width
int         avg_char_height;  // average character height

LogfontDlg *ptrdlg;           // the modeless dialog
CDC        *ptrprinter;       // the default printer

 /***************************************************************************/
 /*                                                                         */
 /* Class Functions:                                                        */
 /*                                                                         */
 /***************************************************************************/

public:
              FrameWin (CWnd*, const char*); // constructor
             ~FrameWin ();               // destructor - remove dialog
void          CmMapFont ();              // responds to Match Font btn press

protected:

afx_msg int   OnCreate (LPCREATESTRUCT); // set up and launch the dialog
afx_msg void  OnPaint ();                // construct font and show test line
        void  GetAvgCharDims (CDC&);     // get avg char dims for font in DC

DECLARE_MESSAGE_MAP()
};
