#pragma once

class FrameWin;  // forward reference

/***************************************************************************/
/*                                                                         */
/* LogfontDlg Class: Modeless Dialog to set and show LOGFONT values and    */
/*                   when Match Font is selected, to display the resultant */
/*                   TEXTMETRICS values                                    */
/*                                                                         */
/***************************************************************************/

class LogfontDlg : public CDialog {

 /***************************************************************************/
 /*                                                                         */
 /* Class Data Members                                                      */
 /*                                                                         */
 /***************************************************************************/

public:

/***************************************************************************/
/*                                                                         */
/* transfer buffer for LOGFONT controls and for TEXTMETRICS data           */
/*                                                                         */
/* Note that the transfer buffer members must be defined in the order that */
/* the controls are allocated in the dialog constructor                    */
/* Specifically, here I am letting the controls be automatically created - */
/* therefore, they must be in the order that the radio buttons are defined */
/* in the resource file. Note that the first radio button of the group has */
/* the WS_GROUP added to it to indicate start of group and the group       */
/* control is defined after the last radio button of the group.            */
/*                                                                         */
/***************************************************************************/

 CString height;
 CString width;
 CString facename;
 int  pitch;
 int  family;
 int  weight;
 int  charset;
 int  quality;
 int  italic;
 int  underline;
 int  strikeout;
 int  clip;
 int  output;
 int  screen;
 int  printer;
 char text01[50];
 char text02[50];
 char text03[50];
 char text04[50];
 char text05[50];
 char text06[50];
 char text07[50];
 char text08[50];
 char text09[50];
 char text10[50];
 char text11[50];
 char text12[50];
 char text13[50];
 char text14[50];
 char text15[50];
 char text16[70];
 char text17[50];
 char text18[50];
 char text19[50];
 char text20[50];

protected:
                            // the Real Transfer Data
LOGFONT    *ptrlf;          // parent's LOGFONT structure
TEXTMETRIC *ptrtm;          // parent's TEXTMETRICS structure
FrameWin   *ptrparent;      // the parent class
BOOL       *ptrisprinter;   // parent's display or printer DC indicator

 /***************************************************************************/
 /*                                                                         */
 /* Class Functions:                                                        */
 /*                                                                         */
 /***************************************************************************/

public:
             LogfontDlg (FrameWin*, LOGFONT*, TEXTMETRIC*, BOOL*);

        void CmMatchFont ();                   // go match the font
        void Reset ();                         // reset the dlg controls after
                                               // a match
virtual void DoDataExchange (CDataExchange*);  // xfer data to and from dlg btns
        void DoExchange (CDataExchange*);      // actually transfers the data

DECLARE_MESSAGE_MAP()
};
