class Function;

class GraphDoc : public CDocument {
protected: // create from serialization only
	GraphDoc();
	DECLARE_DYNCREATE(GraphDoc)

public:
 bool         isnew;              // TRUE for a new document
 bool         metafile_available; // TRUE when metafile exists
 bool         use_metafile_only;  // TRUE when no graph instance exists

 char         tempname[MAX_PATH]; // new metafile name
 CMetaFileDC  dc;                 // the DC for the metafile creates
 HENHMETAFILE hMetafile;          // the metafile proper

 int          which_graph;        // which graph to construct
 int          num_pts;            // the number of points to use in the graph
 double       parm1;              // the graph construction parameters
 double       parm2;
 Function    *ptrfn;              // graph base class 

 bool         is_open_title_call; // patch to retain Open doc title
 int          num_calls;          // count of SetTitle calls - bypass #2

 RECT        *ptrmargins;         // saved PageSetup's margins

public:
        void  SetMargins (PAGESETUPDLG*); // install our page margins
        void  SaveMargins (RECT*);        // save page setup margins
        RECT* GetMargins ();              // returns the margins

	virtual BOOL OnNewDocument();                     // open new graph
	virtual BOOL OnOpenDocument(LPCTSTR lpszPathName);// open existing EMF file
	virtual void DeleteContents();                    // remove objects
	virtual BOOL OnSaveDocument(LPCTSTR lpszPathName);// save as EMF file
	virtual void SetTitle(LPCTSTR lpszTitle);         // install caption
	virtual     ~GraphDoc();

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif
	DECLARE_MESSAGE_MAP()
};
