class GraphView : public CView {
protected:
	GraphView();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(GraphView)

 bool   useMetafile;     // true when view is using the metafile to render
 CRect  draw_rect;       // the rect in which to place the graph
 CRect *ptrgraph_rect;   // the graph's size when on-screen
 bool   dragging;        // true while user drags image about the client area
 CPoint init_pt;         // initial point for dragging

public:
	   GraphDoc* GetDocument();
	virtual void OnDraw(CDC* pDC);                    // draws from emf or render
	virtual     ~GraphView();

protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);// set total pages, margins
	virtual void OnPrint(CDC* pDC, CPrintInfo* pInfo);// set drawing rect 
 afx_msg void OnFilePageSetup ();                  // do page setup for margins
	afx_msg void OnViewFromEmf();                     // switch between Render and EMF
	afx_msg void OnUpdateViewFromEmf(CCmdUI* pCmdUI); // enable or checkmark menuitem
	afx_msg void OnSetGraphSize();                    // get user graph size
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point); // enable graph dragging
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);   // end dragging
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);   // move graph 
	afx_msg void OnUpdateViewHeader(CCmdUI* pCmdUI);
	afx_msg void OnViewHeader();

DECLARE_MESSAGE_MAP()
public:
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif
};
#ifndef _DEBUG  // debug version in GraphView.cpp
inline GraphDoc* GraphView::GetDocument()
   { return (GraphDoc*)m_pDocument; }
#endif
