// file: BASEFRAM.CPP

#include "stdafx.h"      // all needed owl includes
#pragma   hdrstop

#include "basefram.h"     // the base frame window Class
#include "sysinfo.h"      // access to system information
//#include "mapwin.hpp"       // access to map window client

#include "resource.h"      // access to WW2 string ids

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
};

#define INITSCROLL  25      // initial scroll percentage
#define INITZOOM     2      // initial zoom factor
#define INITSCALE 6000      // initial map scale
#define INITLAT      0      // initial map position
#define INITLON      0

/***************************************************************************/
/*                                                                         */
/* BaseFrame: demo map actions - derive working classes from this class    */
/*                                                                         */
/***************************************************************************/

/***************************************************************************/
/*                                                                         */
/* BaseFrame Events Section                                                */
/*                                                                         */
/***************************************************************************/

BEGIN_MESSAGE_MAP(BaseFrame, CFrameWnd)
 ON_WM_CREATE ()
 ON_WM_DESTROY ()
 ON_WM_CLOSE ()
 ON_BN_CLICKED (CM_MAPCB_UPLEFT, CmUpLeft)
 ON_BN_CLICKED (CM_MAPCB_UP, CmUp)
 ON_BN_CLICKED (CM_MAPCB_UPRIGHT, CmUpRight)
 ON_BN_CLICKED (CM_MAPCB_LEFT, CmLeft)
 ON_BN_CLICKED (CM_MAPCB_RIGHT, CmRight)
 ON_BN_CLICKED (CM_MAPCB_SETSCALE, CmSetCenter)
 ON_BN_CLICKED (CM_MAPCB_DOWNLEFT, CmUpLeft)
 ON_BN_CLICKED (CM_MAPCB_DOWN, CmUp)
 ON_BN_CLICKED (CM_MAPCB_DOWNRIGHT, CmUpRight)
 ON_BN_CLICKED (CM_MAPCB_SETCENTER, CmSetCenter)
 ON_BN_CLICKED (CM_MAPCB_SETZOOM, CmSetCenter)
 ON_BN_CLICKED (CM_MAPCB_SETSCROLL, CmSetCenter)
 ON_BN_CLICKED (CM_MAPCB_ZOOM_IN, CmSetCenter)
 ON_BN_CLICKED (CM_MAPCB_ZOOM_OUT, CmSetCenter)
 ON_BN_CLICKED (CM_OPTIONS_SHOW_CITY, CmSetCenter)
 ON_BN_CLICKED (CM_OPTIONS_SHOW_TERRAIN, CmSetCenter)
 ON_BN_CLICKED (CM_OPTIONS_SHOW_FACTORY, CmSetCenter)
 ON_BN_CLICKED (CM_OPTIONS_SHOW_WEATHER, CmSetCenter)
 ON_BN_CLICKED (CM_OPTIONS_SHOW_SHIPYARD, CmSetCenter)
 ON_COMMAND (CM_EXIT, CmUp)


 //EV_COMMAND       (CM_BUTTON_A, CmButtonA),
//  EV_COMMAND_ENABLE(CM_BUTTON_A, CeButtonA),
//  EV_COMMAND       (CM_BUTTON_B, CmButtonB),
//  EV_COMMAND_ENABLE(CM_BUTTON_B, CeButtonB),
END_MESSAGE_MAP ()
/*
void BaseFrame::CeButtonA (TCommandEnabler &ce) {ce.Enable (TRUE);}

void BaseFrame::CmButtonA () {
 thisday += 55;
 DisplayGameDayTime();
 if (thisday.NewWeek ()) DisplayCaptionBar ();
 ptrmapwin->UpdateDateTimeUT (thisday);
}

void BaseFrame::CeButtonB (TCommandEnabler &ce) {ce.Enable (TRUE);}

void BaseFrame::CmButtonB () {
 thisday += 1440;
 DisplayGameDayTime();
 if (thisday.NewWeek ()) DisplayCaptionBar ();
 ptrmapwin->UpdateDateTimeUT (thisday);
}
  */

void  BaseFrame::CmUpLeft () {}
void  BaseFrame::CmUp () {}
void  BaseFrame::CmUpRight () {}
void  BaseFrame::CmLeft () {}
void  BaseFrame::CmRight () {}
void  BaseFrame::CmSetCenter () {}


/***************************************************************************/
/*                                                                         */
/* BaseFrame: constructor                                                  */
/*                                                                         */
/***************************************************************************/

      BaseFrame::BaseFrame (CWnd *ptrparent, CString title, BOOL &success,
                            MapControl *ptrinitcontrol = NULL)
                    : CFrameWnd () {
 maintitle = title;
 success = FALSE;
 hs = AfxGetApp()->m_hInstance;

 // EnableToolTips (TRUE);
// ptrmapwin           = NULL;
 ptrmapcontrol       = NULL;

 DWORD style = WS_OVERLAPPEDWINDOW | WS_MAXIMIZE; // set window styles
 CRect rect (10, 10, 600, 450);               // set init pos and size

 LoadAccelTable ("IDA_BASEFRAME_ACCEL");      // install keybd accelerators
           
 Create ( AfxRegisterWndClass (
               CS_VREDRAW | CS_HREDRAW,       // register window style UINT
               AfxGetApp()->LoadStandardCursor (IDC_ARROW), // use arrow cur
               (HBRUSH) GetStockObject (BLACK_BRUSH),      // gray brush
               AfxGetApp()->LoadIcon (IDI_WW2_ICON)),// set min icon
          title,               // window caption
          style,               // wndclass DWORD style
          rect,                // set initial window position
          ptrparent,           // the parent window, here none
          MAKEINTRESOURCE(IDM_BASEFRAME_MENU));        // assign the main menu

 // setup map control class
 if (ptrinitcontrol != NULL) { // using another's map controller
  ptrmapcontrol = ptrinitcontrol;
  isourmapcontrol = FALSE;
 }
 else { // get new map controller
  Position pos (INITLAT, INITLON);
  short scroll = INITSCROLL;
  short zoom   = INITZOOM;
  double scale = INITSCALE;
  ptrmapcontrol = new MapControl (pos, scroll, zoom, scale);
  if (!ptrmapcontrol) return;
  isourmapcontrol = TRUE; // success
 }

 // load the header messages for the controls
 LoadString (hs, IDS_CAPTION_PHASE_DEMO, thisphasemsg, sizeof(thisphasemsg));
 LoadString (hs, IDS_CAPTION_GAME_PHASE, phasehdrmsg, sizeof (phasehdrmsg));
 LoadString (hs, IDS_CAPTION_GAME_WEEK, weekhdrmsg, sizeof (weekhdrmsg));
 LoadString (hs, IDS_MLS_GAMEDAY, dayhdrmsg, sizeof (dayhdrmsg));
 LoadString (hs, IDS_MLS_GAMETIMEUT, timeuthdrmsg, sizeof (timeuthdrmsg));
 // set default date and time
 thisday.SetDateTime (9L, 1L, 1939L, 6L, 0L);

 // now load any saved values from the WW2.INI file
 ReadSetUpProfileData (ptrmapcontrol, thisday);

 /***************************************************************************/
 /*                                                                         */
 /* attempt to allocate the map window                                      */
 /*                                                                         */
 /***************************************************************************/
/*
 ptrmapwin = new MapWin (this, success, ptrmapcontrol, thisday);
 if (ptrmapwin == 0 || success == FALSE) {
  DisplayMsg (IDS_WW2ERR_HEADER, IDS_WW2ERR_MAPERROR, MB_OK);
  if (ptrmapwin) delete ptrmapwin;
  ptrmapwin = NULL;
  success = FALSE;
  return;
 }
 */
 DisplayGameDayTime ();            // insert day and UT time into high statusbar
 DisplayCaptionBar ();             // insert game phase and week into caption
 success = TRUE;
}
 
/***************************************************************************/
/*                                                                         */
/* OnCreate: construct status and control bars                             */
/*                                                                         */
/***************************************************************************/

int      BaseFrame::OnCreate (LPCREATESTRUCT lpCS) {

 int retcd;
 if ((retcd = CFrameWnd::OnCreate (lpCS)) == 0) // pass along to base class
  // if successful, create the control bar & then if all ok, create status bar
  // then create the tool box - for each, Create constructs the object
  // and if successful, the corresponding bitmap of buttons is loaded
  // and if successful, the buttons are initialized
  if (maplocalstatsbar.Create (this))
   if (mapcontrolbar.Create (this)) 
    if (mainstatusbar.Create (this) &&
        mainstatusbar.SetIndicators (indicators,
                                		  sizeof (indicators) / sizeof (UINT)))
     if (optionsbar.Create (this)) ;
     else return -1;
    else return -1; 
   else return -1;
  else return -1;

// toolbox.SetColumns (2); // set the tool box to 2 columns

 // now install flyover hints and the tool tips for both controlbar & tool box
// toolbar.SetBarStyle (toolbar.GetBarStyle() | CBRS_TOOLTIPS | CBRS_FLYBY);
// mapcontrolbar.SetBarStyle (mapcontrolbar.GetBarStyle() | CBRS_TOOLTIPS | CBRS_FLYBY);
// maplocalstatsbar.SetBarStyle (maplocalstatsbar.GetBarStyle() | CBRS_TOOLTIPS | CBRS_FLYBY);
// optionsbar.SetBarStyle (optionsbar.GetBarStyle() | CBRS_TOOLTIPS | CBRS_FLYBY);

 // now notify control to accept any form of docking
 mapcontrolbar.EnableDocking (0);//CBRS_ALIGN_ANY);
 maplocalstatsbar.EnableDocking (0);//CBRS_ALIGN_ANY);
 optionsbar.EnableDocking (0);//CBRS_ALIGN_ANY);

 // insert captions to be shown when the tool bars are floating
 maplocalstatsbar.SetWindowText(_T("Map Local Stats"));
 mapcontrolbar.SetWindowText(_T("Map Controls"));
 optionsbar.SetWindowText(_T("Opt"));

 // notify the framewindow of docking requirements
 EnableDocking (CBRS_ALIGN_ANY);

 // and dock tooll bar at the top and the tool box on the right
// DockControlBar (&where_at_time_cb);//AFX_IDW_DOCKBAR_RIGHT);
 CRect r;
 GetClientRect (&r);
 CRect q;
 maplocalstatsbar.GetClientRect (&q);
 CPoint p (r.right - q.Width(), r.top + 30);
 FloatControlBar (&maplocalstatsbar, p);//AFX_IDW_DOCKBAR_RIGHT);
 p.y += 100;
 FloatControlBar (&optionsbar, p);
 mapcontrolbar.GetClientRect (&q);
 p.x = r.right - q.Width ();
 p.y = r.bottom - q.Height ();
 FloatControlBar (&mapcontrolbar, p);
// DockControlBar (&mapcontrolbar, AFX_IDW_DOCKBAR_BOTTOM);

 return retcd;   
}

/***************************************************************************/
/*                                                                         */
/* ReadSetUpProfileData - input any position, map values, and date/time    */
/*                                                                         */
/***************************************************************************/

void      BaseFrame::ReadSetUpProfileData (MapControl *ptrmapcontrol,
                                           DateTime &thisday) {
 char section[40];
 char entry[40];
 long mon, day, yr, hrs, min;
 char latstr[10], lonstr[10];
 long lat, lon;

 LoadString (hs, IDS_WW2_PROFILE_DEMOMAP, section, sizeof(section));
 LoadString (hs, IDS_WW2_PROFILE_YR, entry, sizeof (entry));
 yr = GetPrivateProfileInt (section, entry, 1939, SysInfo::file_ww2_ini);
 LoadString (hs, IDS_WW2_PROFILE_MON, entry, sizeof (entry));
 mon = GetPrivateProfileInt (section, entry, 9, SysInfo::file_ww2_ini);
 LoadString (hs, IDS_WW2_PROFILE_DAY, entry, sizeof (entry));
 day = GetPrivateProfileInt (section, entry, 1, SysInfo::file_ww2_ini);
 LoadString (hs, IDS_WW2_PROFILE_HRS, entry, sizeof (entry));
 hrs = GetPrivateProfileInt (section, entry, 6, SysInfo::file_ww2_ini);
 LoadString (hs, IDS_WW2_PROFILE_MIN, entry, sizeof (entry));
 min = GetPrivateProfileInt (section, entry, 0, SysInfo::file_ww2_ini);
 thisday.SetDateTime (mon, day, yr, hrs, min);

 LoadString (hs, IDS_WW2_PROFILE_LAT, entry, sizeof (entry));
 GetPrivateProfileString (section, entry, "0", latstr, sizeof (latstr),
                          SysInfo::file_ww2_ini);
 LoadString (hs, IDS_WW2_PROFILE_LON, entry, sizeof (entry));
 GetPrivateProfileString (section, entry, "0", lonstr, sizeof (lonstr),
                          SysInfo::file_ww2_ini);
 lat = atol (latstr);
 lon = atol (lonstr);
 ptrmapcontrol->center_pos.SetLatLon (lat, lon);

 LoadString (hs, IDS_WW2_PROFILE_ZOOM, entry, sizeof (entry));
 hrs = GetPrivateProfileInt (section, entry, 2, SysInfo::file_ww2_ini);
 LoadString (hs, IDS_WW2_PROFILE_SCROL, entry, sizeof (entry));
 min = GetPrivateProfileInt (section, entry, 25, SysInfo::file_ww2_ini);
 LoadString (hs, IDS_WW2_PROFILE_SCALE, entry, sizeof (entry));
 GetPrivateProfileString (section, entry, "6000", lonstr, sizeof (lonstr),
                          SysInfo::file_ww2_ini);
 ptrmapcontrol->scale = atof (lonstr);
 ptrmapcontrol->zoom_factor = (short) hrs;
 ptrmapcontrol->scroll_percent = (short) min;
}

/***************************************************************************/
/*                                                                         */
/* WriteSetUpProfileData - output any position, map values, and date/time  */
/*                                                                         */
/***************************************************************************/
  
void      BaseFrame::WriteSetUpProfileData (MapControl *ptrmapcontrol,
                                            DateTime &thisday) {
 char section[40];
 char entry[40];
 long  mon, day, yr, hrs, min;
 char latstr[10], lonstr[10];

 thisday.GetDateTime (mon, day, yr, hrs, min);
 LoadString (hs, IDS_WW2_PROFILE_DEMOMAP, section, sizeof(section));
 LoadString (hs, IDS_WW2_PROFILE_YR, entry, sizeof (entry));
 wsprintf (latstr, "%ld", yr);
 WritePrivateProfileString (section, entry, latstr, SysInfo::file_ww2_ini);
 LoadString (hs, IDS_WW2_PROFILE_MON, entry, sizeof (entry));
 wsprintf (latstr, "%ld", mon);
 WritePrivateProfileString (section, entry, latstr, SysInfo::file_ww2_ini);
 LoadString (hs, IDS_WW2_PROFILE_DAY, entry, sizeof (entry));
 wsprintf (latstr, "%ld", day);
 WritePrivateProfileString (section, entry, latstr, SysInfo::file_ww2_ini);
 LoadString (hs, IDS_WW2_PROFILE_HRS, entry, sizeof (entry));
 wsprintf (latstr, "%ld", hrs);
 WritePrivateProfileString (section, entry, latstr, SysInfo::file_ww2_ini);
 LoadString (hs, IDS_WW2_PROFILE_MIN, entry, sizeof (entry));
 wsprintf (latstr, "%ld", min);
 WritePrivateProfileString (section, entry, latstr, SysInfo::file_ww2_ini);

 wsprintf (latstr, "%ld", ptrmapcontrol->center_pos.Latitude);
 wsprintf (lonstr, "%ld", ptrmapcontrol->center_pos.Longitude);
 LoadString (hs, IDS_WW2_PROFILE_LAT, entry, sizeof (entry));
 WritePrivateProfileString (section, entry, latstr, SysInfo::file_ww2_ini);
 LoadString (hs, IDS_WW2_PROFILE_LON, entry, sizeof (entry));
 WritePrivateProfileString (section, entry, lonstr, SysInfo::file_ww2_ini);

 LoadString (hs, IDS_WW2_PROFILE_ZOOM, entry, sizeof (entry));
 wsprintf (latstr, "%d",  ptrmapcontrol->zoom_factor);
 WritePrivateProfileString (section, entry, latstr, SysInfo::file_ww2_ini);
 LoadString (hs, IDS_WW2_PROFILE_SCROL, entry, sizeof (entry));
 wsprintf (latstr, "%d",  ptrmapcontrol->scroll_percent);
 WritePrivateProfileString (section, entry, latstr, SysInfo::file_ww2_ini);
 LoadString (hs, IDS_WW2_PROFILE_SCALE, entry, sizeof (entry));
 sprintf (latstr, "%f", ptrmapcontrol->scale);
 WritePrivateProfileString (section, entry, latstr, SysInfo::file_ww2_ini);
}

/***************************************************************************/
/*                                                                         */
/* DisplayGameDayTime: display game's day and UT time in high status bar   */
/*                                                                         */
/***************************************************************************/

void      BaseFrame::DisplayGameDayTime () {

 char msg  [40];

 thisday.FormatDay (thisdaymsg, FALSE); // format the current day and time
 thisday.FormatHM (thistimeutmsg);

 LoadString (hs, IDS_MLS_GAMEDAY, msg, sizeof(msg));
 strcat (msg, thisdaymsg);
 maplocalstatsbar.DisplayDay (msg);

 LoadString (hs, IDS_MLS_GAMETIMEUT, msg, sizeof(msg));
 strcat (msg, thistimeutmsg);
 maplocalstatsbar.DisplayTimeUT (msg);
}

/*****************************************************************************/
/*                                                                           */
/* DisplayCaptionBar: install game's phase and week of action into title bar */
/*                                                                           */
/*****************************************************************************/

void      BaseFrame::DisplayCaptionBar () {

 thisday.FormatWeekWithDay (thisweekmsg, FALSE);

 strcpy (caption, maintitle);
 strcat (caption, "     ");
 strcat (caption, phasehdrmsg);
 strcat (caption, thisphasemsg);
 strcat (caption, "    ");
 strcat (caption, weekhdrmsg);
 strcat (caption, thisweekmsg);
 strcat (caption, "    ");

 SetWindowText (caption);
}

/***************************************************************************/
/*                                                                         */
/* OnDestroy: remove all objects                                           */
/*                                                                         */
/***************************************************************************/

void      BaseFrame::OnDestroy () {

// if (ptrmapwin) delete ptrmapwin;
 if (isourmapcontrol && ptrmapcontrol) delete ptrmapcontrol;
}

/***************************************************************************/
/*                                                                         */
/* BaseFrame: destructor                                                   */
/*                                                                         */
/***************************************************************************/

          BaseFrame::~BaseFrame () {
}

/***************************************************************************/
/*                                                                         */
/* OnClose: query user about shutting down the whole game                  */
/*                                                                         */
/***************************************************************************/

void      BaseFrame::OnClose () {

 BOOL retcd = FALSE;
/*
 if ((ptrmapwin && ptrmapwin->CanClose ()) || !ptrmapwin) {
  retcd = DisplayMsg (IDS_WW2_NAME, IDS_WW2_CLOSEAPP,
                      MB_YESNO|MB_ICONQUESTION) == IDYES;
  if (retcd) {
   if (DisplayMsg (IDS_WW2_NAME,IDS_WW2_PROFILE_SAVE,
                   MB_YESNO|MB_ICONQUESTION) == IDYES) {
    SysInfo::WriteStartUpProfileHdr (0);
    WriteSetUpProfileData (ptrmapcontrol, thisday);
   }
  }
 }
 */
 //if (retcd)
 CFrameWnd::OnClose ();
}

/***************************************************************************/
/*                                                                         */
/* DisplayMsg: displays a message box returning the user's response        */
/*                                                                         */
/***************************************************************************/

long      BaseFrame::DisplayMsg (long id1, long id2, UINT flags) {

 CString msg1, msg2;

 msg1.LoadString (id1);
 msg2.LoadString (id2);
 return MessageBox (msg2, msg1, flags);
}

/***************************************************************************/
/*                                                                         */
/* DisplayMapNowAtValues: show the where, location, date, time local etc   */
/*                                                                         */
/***************************************************************************/

void      BaseFrame::DisplayMapNowAtValues (char *mnam, char *mpos, char *mtl,
                                            char *mdl,  char *mrise, char *mset,
                                            char *mw, char *mg) {
 maplocalstatsbar.DisplayMapNowAtValues (mnam, mpos, mtl, mdl, mrise, mset,
                                         mw, mg);
}

/***************************************************************************/
/*                                                                         */
/* DisplayMainStatusBar: show a message on the main status bar             */
/*                                                                         */
/***************************************************************************/

void      BaseFrame::DisplayMainStatusBar (char *s) {
 mainstatusbar.SetPaneText (0, s);
}

/***************************************************************************/
/*                                                                         */
/* GetMapControl: returns a pointer to the current map control object      */
/*                                                                         */
/***************************************************************************/

MapControl*  BaseFrame::GetMapControl () {
 return ptrmapcontrol;
}
