// file: BASEFRAM.HPP

#ifndef BASEFRAMHPP
#define BASEFRAMHPP

#include "stdafx.h"      // all needed owl includes
#pragma   hdrstop

//#include "highsbar.hpp"     // access to high level statusbar
//#include "actsbar.hpp"      // access to the actions statusbar
#include "OptionsBar.h"       // access to the options controlbar
#include "MapControlBar.h"    // access to the map control bar
#include "MapLocalStatsBar.h" // access to the map local stats bar
#include "mapcntrl.h"         // access to map control
#include "date.h"
#include "time.h"
#include "datetime.h"

//class MapWin;               // forward reference

/***************************************************************************/
/*                                                                         */
/* BaseFrame: base frame win illustrates basic demo - derive from it       */
/*                                                                         */
/***************************************************************************/

class BaseFrame : public CFrameWnd {

 /***************************************************************************/
 /*                                                                         */
 /* Data Members                                                            */
 /*                                                                         */
 /***************************************************************************/

public:

// MapWin           *ptrmapwin;          // the main view map window
CString              maintitle;          // main caption title

// HighStatusBar    *ptrhighstatusbar;   // the top status control
// ActionStatusBar  *ptractionstatusbar; // the below map status bar
// ActionControlBar *ptractioncontrolbar;// the action control bar

 MapControl       *ptrmapcontrol;      // public access to map control data
 BOOL              isourmapcontrol;    // TRUE when we allocated a MapControl

 DateTime          thisday ;           // game day and UT time

protected:

 char             phasehdrmsg[8];      // the header Phase:
 char             weekhdrmsg[20];      // the header Week:
 char             dayhdrmsg[8];        // the header Day:
 char             timeuthdrmsg[10];    // the header Time (UT):

 char             thisphasemsg[30];    // current phase
 char             thisweekmsg[30];     // current week
 char             thisdaymsg[60];      // current day
 char             thistimeutmsg[30];   // current ut time

 char             caption[150];        // current complete title caption
 
 HINSTANCE        hs;                  // our instance for LoadStrings

 MapLocalStatsBar maplocalstatsbar;    // map local stat bar
 CStatusBar       mainstatusbar;
 MapControlBar    mapcontrolbar;       // map control bar
 OptionsBar       optionsbar;

 /***************************************************************************/
 /*                                                                         */
 /* Functions:                                                              */
 /*                                                                         */
 /***************************************************************************/

 public:

          BaseFrame (CWnd*, CString, BOOL&, MapControl*); // constructor
         ~BaseFrame ();                                 // destructor

 MapControl* GetMapControl ();    // gets the map control data

        void        DisplayCaptionBar (); // install game data into the titlebar
        void        DisplayGameDayTime ();// display game day & time in high sb

 // access to control and status bar functions
/*
 void     DisplayMapCtlValues (char *cen, char *sca, char *zom,
                                         char *scr) {
                                         ptrhighstatusbar-> DisplayMapCtlValues(
                                                            cen, sca, zom, scr);
                                        }
*/
void      DisplayMapNowAtValues (char *mnam, char *mpos, char *mtl,
                                 char *mdl,  char *mrise, char *mset,
                                 char *mw, char *mg);
void      DisplayMainStatusBar (char *s);

/* void        DisplayInfoHeading (char *s) {
                                      ptrmaincontrolbar->DisplayInfoHeading (s);
                                     }
 void        DisplayInfoWindow  (char *s) {
                                       ptrmaincontrolbar->DisplayInfoWindow (s);
                                      }
*/
void      ReadSetUpProfileData  (MapControl*, DateTime&);
void      WriteSetUpProfileData (MapControl*, DateTime&);

 protected:

afx_msg int   OnCreate (LPCREATESTRUCT lpCreateStruct);
afx_msg void  OnDestroy ();               // remove resources
afx_msg void  OnClose ();                 // handle app shutdown
        long  DisplayMsg (long, long, UINT);  // displays msgs
        void  CmUpLeft ();
        void  CmUp ();
        void  CmUpRight ();
        void  CmLeft ();
        void  CmRight ();
        void  CmSetCenter ();
 /*
        void        CmButtonA ();
        void        CeButtonA (TCommandEnabler&);
        void        CmButtonB ();
        void        CeButtonB (TCommandEnabler&);
 */
DECLARE_MESSAGE_MAP();      // menu operations placeholder
};
#endif

