#pragma once
/***************************************************************************/
/*                                                                         */
/* CDib Class Definition                                                   */
/*                                                                         */
/***************************************************************************/

class CDib {

 /***************************************************************************/
 /*                                                                         */
 /* Class Data Members                                                      */
 /*                                                                         */
 /***************************************************************************/

protected:

HANDLE  hdib;                    // handle for the DIB in memory
BYTE   *ptrdib;                  // locked ptr to the DIB
DWORD   numcolors;               // the number of colors in this DIB
UINT    dwDibSize;               // saved size of DIB for gray copy

 /***************************************************************************/
 /*                                                                         */
 /* Class Functions:                                                        */
 /*                                                                         */
 /***************************************************************************/

public:

       CDib (CFile*);            // construct a memory DIB from a .BMP file
       CDib (CDib*);             // construct gray DIB from existing DIB
      ~CDib ();                  // removed the DIB

BOOL   IsValid ();               // returns TRUE is DIB is loaded and ready
void   MakePalette (CPalette*);  // constructs a color palette from DIB
BOOL   MakeIdentityPalette (CPalette*); // constructs an identity color palette
BYTE*  GetDibBitsAddr ();        // returns a pointer to the DIB data bits
int    GetDibWidth ();           // returns the width of the DIB in pixels
int    GetDibHeight ();          // returns the height of the DIB in pixels
LPBITMAPINFO GetBitmapInfo ();   // returns ptr to the BITMAPINFO section

protected:
void   ReadDibFile (CFile*);     // input the DIB file, constructing DIB object
void   GrayDib (CDib*);          // convert copy CDib into a gray Dib
};
