#pragma once
/***************************************************************************/
/*                                                                         */
/* FONTITEM structure                                                      */
/*                                                                         */
/***************************************************************************/

struct FONTITEM {
 LOGFONT lf;
 BOOL    ttFont;
};

/***************************************************************************/
/*                                                                         */
/* FontEnumComboBox: User Font Selection Via ComboBox in a toolbar         */
/*                                                                         */
/***************************************************************************/

class FontEnumComboBox : public CComboBox {
// Construction
public:
	FontEnumComboBox();

protected:
LOGFONT    *ptrlf;        // the transfer LOGFONT buffer
CPtrArray   fonts_array;  // the array of font items
int         curfontid;    // the combo box id of current font

protected:
        void  BuildFontList (CDC*); // enum fonts and build array
        void  AddFontsToList ();    // add array of fonts to list view
afx_msg void  OnSelChange();
public:
// call back font enumeration function
static  BOOL CALLBACK AFX_EXPORT  EnumPrinterFonts (ENUMLOGFONT*,
                                  NEWTEXTMETRICEX*, int, LPVOID);
virtual BOOL PreTranslateMessage(MSG* pMsg);
virtual BOOL Create (DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID);
virtual     ~FontEnumComboBox();
	DECLARE_MESSAGE_MAP()
};
