#include "stdafx.h"
#include "Pgm10a.h"
#include "GeoDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/***************************************************************************/
/*                                                                         */
/* GeoDoc: container for the CDib Object                                   */
/*                                                                         */
/***************************************************************************/

IMPLEMENT_DYNCREATE(GeoDoc, CDocument)

BEGIN_MESSAGE_MAP(GeoDoc, CDocument)
END_MESSAGE_MAP()

GeoDoc::GeoDoc() {
 ptrdocdib  = NULL;
}

GeoDoc::~GeoDoc() {
 if (ptrdocdib)  delete ptrdocdib;
}

BOOL GeoDoc::OnNewDocument() {
	if (!CDocument::OnNewDocument())
		return FALSE;
	return TRUE;
}

/***************************************************************************/
/*                                                                         */
/* Serialization: construct the CDib object                                */
/*                                                                         */
/***************************************************************************/

void GeoDoc::Serialize(CArchive& ar) {
	if (ar.IsStoring()) 	{
	}
	else 	{
  CFile *ptrfile = ar.GetFile ();    // get the CFile in use
  ptrdocdib = new CDib (ptrfile);    // construct the DIB using the CFile
  if (!ptrdocdib || !ptrdocdib->IsValid ()) {
   AfxMessageBox ("Bmp Viewer Error: Unable to Load the .BMP file", MB_OK);
   delete ptrdocdib;
  }
	}
}

/***************************************************************************/
/*                                                                         */
/* GetDib: returns ptr to the CDib object                                  */
/*                                                                         */
/***************************************************************************/

CDib*     GeoDoc::GetDib () {
 if (ptrdocdib && ptrdocdib->IsValid ()) return ptrdocdib;
 else return NULL;
}

#ifdef _DEBUG
void GeoDoc::AssertValid() const { CDocument::AssertValid(); }
void GeoDoc::Dump(CDumpContext& dc) const { CDocument::Dump(dc); }
#endif //_DEBUG

void GeoDoc::DeleteContents() {
 if (ptrdocdib) delete ptrdocdib;
 ptrdocdib  = NULL;
	CDocument::DeleteContents();
}
