#pragma once
#include "Position.h"
#include "CDib.h"

class GeoView : public CScrollView {
protected: // create from serialization only
	GeoView();
	DECLARE_DYNCREATE(GeoView)

 Position center;
 double   scale;
 int      zoom;
 int      scroll;
 char     date[20];
 char     time[20];
 CDib     *ptrdib;          // the CDib itself
 CPalette *ptrpalette;      // the palette for the memory dc
 CSize     bmp_size;        // the size of the DIB
 CSize     t_size;          // CScrollView scrolling total size
 LOGFONT  *ptrlf;

public:
     	GeoDoc* GetDocument();
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual void OnInitialUpdate();
	virtual     ~GeoView();
        void  OnUpdate (CView*, LPARAM, CObject*); // reset settings/scroll val

protected:
 void ReadSetUpProfileData ();
 void WriteSetUpProfileData ();

 afx_msg void  CmDummy ();
	afx_msg void  OnDestroy();
 afx_msg void  OnKeyDown (UINT key, UINT, UINT); // provide keybd scroll help
 afx_msg void  OnPaletteChanged (CWnd*);         // make best of another palette
 afx_msg BOOL  OnQueryNewPalette ();             // reset palette when gain focus

 LRESULT  FontChange (WPARAM, LPARAM);         // respond to font changes
 LRESULT  OnDisplayChange (WPARAM, LPARAM);    // changed display settings
 void     AdjustBmpLoading ();                 // handle new load options
 void     AdjustDisplayOptions ();             // handle new display options
 void     RemoveObjects ();                    // deletes all memory DC obj

public:
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in Pgm10aView.cpp
inline GeoDoc* GeoView::GetDocument()
   { return (GeoDoc*)m_pDocument; }
#endif
