#include "stdafx.h"
#pragma   hdrstop
#include "MapControlBar.h" 
#include "resource.h"

/***************************************************************************/
/*                                                                         */
/* MapControlBar: Houses map button controls, arrow cluster, dlg launchers */
/*                                                                         */
/***************************************************************************/

/***************************************************************************/
/*                                                                         */
/* MapControlBar: constructor                                              */
/*                                                                         */
/***************************************************************************/

MapControlBar::MapControlBar () : CDialogBar () {
 EnableToolTips (TRUE);
 HINSTANCE hs = AfxGetApp()->m_hInstance;
 LoadString (hs, IDS_MAPCB_CENTERPOS, scen,    sizeof(scen));
 LoadString (hs, IDS_MAPCB_ZOOM,      szoom,   sizeof(szoom));
 LoadString (hs, IDS_MAPCB_SCROLL,    sscroll, sizeof(sscroll));
 LoadString (hs, IDS_MAPCB_SCALE,     sscale,  sizeof(sscale));
}

/***************************************************************************/
/*                                                                         */
/* Create: setup the Map control dialog bar                                */
/*                                                                         */
/***************************************************************************/

BOOL      MapControlBar::Create (CWnd *ptrparent) {
 if (CDialogBar::Create (ptrparent, IDD_MAP_CONTROLS,
                         //CBRS_BOTTOM
                         CBRS_FLOATING
                         | CBRS_TOOLTIPS | CBRS_FLYBY,
                         AFX_IDW_CONTROLBAR_FIRST+1)) {
  upleft.AutoLoad (CM_MAPCB_UPLEFT, this);
  up.AutoLoad (CM_MAPCB_UP, this);
  upright.AutoLoad (CM_MAPCB_UPRIGHT, this);
  left.AutoLoad (CM_MAPCB_LEFT, this);
  scale.AutoLoad (CM_MAPCB_SETSCALE, this);
  right.AutoLoad (CM_MAPCB_RIGHT, this);
  downleft.AutoLoad (CM_MAPCB_DOWNLEFT, this);
  down.AutoLoad (CM_MAPCB_DOWN, this);
  downright.AutoLoad (CM_MAPCB_DOWNRIGHT, this);
  return TRUE;
 }
 else return FALSE;
}

/***************************************************************************/
/*                                                                         */
/* DisplayCenter: show the map center position in the static control       */
/*                                                                         */
/***************************************************************************/

void     MapControlBar::DisplayCenter (Position *ptrpos) {
 char pos[30];
 char msg[80];
 ptrpos->FormatPosition (pos, sizeof(pos));
 strcpy_s (msg, sizeof(msg), scen);
 strcat_s (msg, sizeof(msg), pos);
 SetDlgItemText (IDC_MAPCB_CENTERPOS, msg);
}

/***************************************************************************/
/*                                                                         */
/* DisplayZoom: show the zoom factor in the static control                 */
/*                                                                         */
/***************************************************************************/

void     MapControlBar::DisplayZoom (int zoom) {
 char msg[80];
 char s[20];
 strcpy_s (msg, sizeof(msg), szoom);
 wsprintf (s, "%d", zoom);
 strcat_s (msg, sizeof(msg), s);
 SetDlgItemText (IDC_MAPCB_ZOOM, msg);
}

/***************************************************************************/
/*                                                                         */
/* DisplayScroll: show the scroll percentage in the static control         */
/*                                                                         */
/***************************************************************************/

void     MapControlBar::DisplayScroll (int scroll) {
 char msg[80];
 char s[20];
 strcpy_s (msg, sizeof(msg), sscroll);
 sprintf_s (s, sizeof(s), "%d", scroll);
 strcat_s (msg, sizeof(msg), s);
 SetDlgItemText (IDC_MAPCB_SCROLL, msg);
}

/***************************************************************************/
/*                                                                         */
/* DisplayScale: show scale value in static control                        */
/*                                                                         */
/***************************************************************************/

void     MapControlBar::DisplayScale (double scale) {
 char msg[80];
 char s[20];
 strcpy_s (msg, sizeof(msg), sscale);
 sprintf_s (s, sizeof(s), "%7.2f", scale);
 strcat_s (msg, sizeof(msg), s);
 SetDlgItemText (IDC_MAPCB_SCALE, msg);
}

/***************************************************************************/
/*                                                                         */
/* DisplayAll: show all four values in the static controls                 */
/*                                                                         */
/***************************************************************************/

void     MapControlBar::DisplayAll (Position *ptrpos, int zoom, int scroll, double scale) {
 DisplayCenter (ptrpos);
 DisplayZoom (zoom);
 DisplayScroll (scroll);
 DisplayScale (scale);
}
