#include "stdafx.h"
#pragma   hdrstop
#include "MapLocalStatsBar.h" 
#include "resource.h"

/***************************************************************************/
/*                                                                         */
/* MapLocalStatsBar: displays local map statistics in a dialog bar         */
/*                                                                         */
/***************************************************************************/

/***************************************************************************/
/*                                                                         */
/* MapLocalStatsBar: constructor                                           */
/*                                                                         */
/***************************************************************************/

MapLocalStatsBar::MapLocalStatsBar () : CDialogBar () {
 EnableToolTips (TRUE);
 HINSTANCE hs = AfxGetApp()->m_hInstance;
 LoadString (hs, IDS_MLS_NAME,       sname,  sizeof(sname));
 LoadString (hs, IDS_MLS_NOW_AT,     snowat, sizeof(snowat));
 LoadString (hs, IDS_MLS_GAMEDAYM,   sgday,  sizeof(sgday));
 LoadString (hs, IDS_MLS_GAMETIMEUTM,sgtime, sizeof(sgtime));
 LoadString (hs, IDS_MLS_TIME_LCL,   stlcl,  sizeof(stlcl));
 LoadString (hs, IDS_MLS_DATE_LCL,   sdlcl,  sizeof(sdlcl));
 LoadString (hs, IDS_MLS_WEATHER,    swea,   sizeof(swea));
 LoadString (hs, IDS_MLS_GROUND,     sgrnd,  sizeof(sgrnd));
 LoadString (hs, IDS_MLS_SUNRISE,    srise,  sizeof(srise));
 LoadString (hs, IDS_MLS_SUNSET,     sset,   sizeof(sset));
}

/***************************************************************************/
/*                                                                         */
/* Create: setup the Map Local Status Bar                                  */
/*                                                                         */
/***************************************************************************/

BOOL      MapLocalStatsBar::Create (CWnd *ptrparent) {
 if (CDialogBar::Create (ptrparent, IDD_MAP_LOCAL_STATS,
                         CBRS_FLOATING | CBRS_TOOLTIPS | CBRS_FLYBY,
                         AFX_IDW_CONTROLBAR_FIRST + 2)) {
  return TRUE;
 }
 else return FALSE;
}

/***************************************************************************/
/*                                                                         */
/* DisplayDay: displays the game date in the control                       */
/*                                                                         */
/***************************************************************************/

void      MapLocalStatsBar::DisplayDay (char *msg) {
 char m[80];
 strcpy_s (m, sizeof(m), sgday);
 strcat_s (m, sizeof(m), msg);
 SetDlgItemText (IDC_MLS_GAMEDAY, m);
}

/***************************************************************************/
/*                                                                         */
/* DisplayTimeUT: displays game time UT in the control                     */
/*                                                                         */
/***************************************************************************/

void      MapLocalStatsBar::DisplayTimeUT (char *msg) {
 char m[80];
 strcpy_s (m, sizeof(m), sgtime);
 strcat_s (m, sizeof(m), msg);
 SetDlgItemText (IDC_MLS_GAMETIMEUT, m);
}

/***************************************************************************/
/*                                                                         */
/* DisplayDayTime: displays game day and time UT in the control            */
/*                                                                         */
/***************************************************************************/

void      MapLocalStatsBar::DisplayDayTime (char *mday, char *mtime) {
 DisplayDay (mday);
 DisplayTimeUT (mtime);
}

/***************************************************************************/
/*                                                                         */
/* DisplayMapNowAtValues: show the where, location, date, time local etc   */
/*                                                                         */
/***************************************************************************/

void      MapLocalStatsBar::DisplayMapNowAtValues (char *mnam, char *mpos, 
                            char *mtl, char *mdl,  char *mrise, char *mset,
                            char *mw, char *mg) {
 char m[80];
 strcpy_s (m, sizeof(m), sname);
 strcat_s (m, sizeof(m), mnam);
 SetDlgItemText (IDC_MLS_CON_AT, m);
 strcpy_s (m, sizeof(m), snowat);
 strcat_s (m, sizeof(m), mpos);
 SetDlgItemText (IDC_MLS_LATLON_AT, m);
 strcpy_s (m, sizeof(m), stlcl);
 strcat_s (m, sizeof(m), mtl);
 SetDlgItemText (IDC_MLS_TIME_LCL, m);
 strcpy_s (m, sizeof(m), sdlcl);
 strcat_s (m, sizeof(m), mdl);
 SetDlgItemText (IDC_MLS_DATE_LCL, m);
 strcpy_s (m, sizeof(m), srise);
 strcat_s (m, sizeof(m), mrise);
 SetDlgItemText (IDC_MLS_SUNRISE, m);
 strcpy_s (m, sizeof(m), sset);
 strcat_s (m, sizeof(m), mset);
 SetDlgItemText (IDC_MLS_SUNSET, m);
 strcpy_s (m, sizeof(m), swea);
 strcat_s (m, sizeof(m), mw);
 SetDlgItemText (IDC_MLS_WEATHER, m);
 strcpy_s (m, sizeof(m), sgrnd);
 strcat_s (m, sizeof(m), mg);
 SetDlgItemText (IDC_MLS_GROUND, m);
}
