#include "stdafx.h"
#include "Pgm10a.h"
#include "PaletteBox.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/***************************************************************************/
/*                                                                         */
/* PaletteBox: constructor - use two columns                               */
/*                                                                         */
/***************************************************************************/

PaletteBox::PaletteBox () {
 m_nColumns       = 2; // set for two columns
 m_cxLeftBorder   = 1; // set 5 pels as a margin
 m_cxRightBorder  = 1; // these fields belong to the base CToolBar class
 m_cyTopBorder    = 1;
 m_cyBottomBorder = 1;
}

PaletteBox::~PaletteBox () { }

/***************************************************************************/
/*                                                                         */
/* GetColumns: return the number of columns in use                         */
/*                                                                         */
/***************************************************************************/

UINT      PaletteBox::GetColumns () {
 return m_nColumns;
}

/***************************************************************************/
/*                                                                         */
/* SetColumns: install number of columns along with radio btn style        */
/*                                                                         */
/***************************************************************************/

void      PaletteBox::SetColumns (UINT numcols) {
 m_nColumns = numcols;

 int numbtns = GetToolBarCtrl ().GetButtonCount (); // get total number btns

 // for each button, install checkbox style
 // for each button that begins a new row, install wrapped style
 for (int i=0; i<numbtns; i++) {
  UINT style = GetButtonStyle (i);        // get current button style
  BOOL wrap = (((i + 1) % numcols) == 0); // set wrap mod num columns
  if (wrap) style |= TBBS_WRAPPED;        // enable wrapped on this one
  else style &= ~TBBS_WRAPPED;            // or disable wrapped
  style |= TBBS_CHECKBOX;                 // add in the check box style
  SetButtonStyle (i, style);              // and save as it's new style
 }
	
 Invalidate ();
 GetParentFrame ()->RecalcLayout ();      // force toolbar to use new layout
}

/***************************************************************************/
/*                                                                         */
/* PaletteBox Message Map                                                  */
/*                                                                         */
/***************************************************************************/

BEGIN_MESSAGE_MAP(PaletteBox, CToolBar)
END_MESSAGE_MAP()
