#include "stdafx.h"
#include "Pgm10a.h"
#include "MainFrame.h"
#include "GeoDoc.h"
#include "GeoView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/***************************************************************************/
/*                                                                         */
/* Pgm10aApp Message Response Table                                        */
/*                                                                         */
/***************************************************************************/

BEGIN_MESSAGE_MAP(Pgm10aApp, CWinApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
END_MESSAGE_MAP()

Pgm10aApp::Pgm10aApp() { }

/***************************************************************************/
/*                                                                         */
/* The actual instance of this app                                         */
/*                                                                         */
/***************************************************************************/

Pgm10aApp theApp;

/***************************************************************************/
/*                                                                         */
/* InitInstance: launch the app with a default file                        */
/*                                                                         */
/***************************************************************************/

BOOL Pgm10aApp::InitInstance () {
 SetRegistryKey ("WindowsMFCII"); // setup the higher level reg key
	LoadStdProfileSettings (); // Load standard INI file options (including MRU)

	// Register document templates
	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate (IDR_MAINFRAME,
		                                      RUNTIME_CLASS (GeoDoc),
              		                        RUNTIME_CLASS (MainFrame),
                                       	RUNTIME_CLASS (GeoView));
	AddDocTemplate (pDocTemplate);

	// Enable DDE Execute open
	EnableShellOpen ();
	RegisterShellFileTypes (TRUE);

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine (cmdInfo);
 // can set a default filename if there are none on the command line
 if (cmdInfo.m_nShellCommand == CCommandLineInfo::FileNew) {
  cmdInfo.m_nShellCommand = CCommandLineInfo::FileOpen;
  cmdInfo.m_strFileName = RetrievePath ();
  if (cmdInfo.m_strFileName.IsEmpty()) 
   cmdInfo.m_strFileName = "res\\Europe.bmp";
 }

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand (cmdInfo))	return FALSE;

	// Enable drag/drop open
	m_pMainWnd->DragAcceptFiles ();

	return TRUE;
}

/***************************************************************************/
/*                                                                         */
/* RetrievePath: obtain the installed path from the system registry        */
/*                                                                         */
/***************************************************************************/

CString   Pgm10aApp::RetrievePath () {
 CString subkey = "SOFTWARE\\WindowsMFCII\\Pgm10a\\Recent File List";
 CString entry = "File1";
 CString filename = "";
 
 HKEY hkey;
 // attempt to open the current user main key with our value
 LONG ok = RegOpenKeyEx (HKEY_CURRENT_USER, subkey, 0, KEY_READ, &hkey);
 if (ok == ERROR_SUCCESS) {
  DWORD dwType, dwCount;
  // key exists, now verify config path entry is a string
  ok = RegQueryValueEx (hkey, entry, NULL, &dwType, NULL, &dwCount);
  if (ok == ERROR_SUCCESS && dwType == REG_SZ) {
   // now retrieve the actual path string
			ok = RegQueryValueEx (hkey, entry, NULL, &dwType,
                         (LPBYTE) filename.GetBuffer (dwCount/sizeof(TCHAR)),
                         &dwCount);
			filename.ReleaseBuffer(); // release the CString buffer locked by GetBuffer
  }
  RegCloseKey (hkey);
 }
 return filename;
}

/***************************************************************************/
/*                                                                         */
/* CAboutDlg Class Definition                                              */
/*                                                                         */
/***************************************************************************/

class CAboutDlg : public CDialog {
public:
	CAboutDlg();
	enum { IDD = IDD_ABOUTBOX };
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD) { }

void CAboutDlg::DoDataExchange(CDataExchange* pDX) {
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()

void Pgm10aApp::OnAppAbout() {
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}
