#pragma once

//           convert long latitude into degrees, minutes, seconds, N/S
void  cvdlat (long &deg, long &min, long &sec, char *ns, long &llat);

//           convert long longitude into degrees, minutes, seconds, E/W
void  cvdlon (long &deg, long &min, long &sec, char *ew, long &llon);

/***************************************************************************/
/*                                                                         */
/* Map Defines: Map Limits and related constants                           */
/*                                                                         */
/***************************************************************************/

#define MAXLON     1296000L              // maximum longitude = 360 degrees
#define HALFLON     648000L              // 180 degrees longitude

#define TOPLAT     80*3600L              // upper map limit = 80 degrees
#define BOTLAT    -60*3600L              // lower map limit = -60 degrees

/***************************************************************************/
/*                                                                         */
/* Position: Stores a map position Latitude and Longitude                  */
/*                                                                         */
/***************************************************************************/

class Position {

 /***************************************************************************/
 /*                                                                         */
 /* Data Members                                                            */
 /*                                                                         */
 /***************************************************************************/

public:

 long Latitude;
 long Longitude;

 /***************************************************************************/
 /*                                                                         */
 /* Functions:                                                              */
 /*                                                                         */
 /***************************************************************************/

public:

     // constructors

                 // null constructor - sets lat, lon to 0
        Position ();

                 // long constructor - sets lat,lon to long values
        Position (long lat, long lon);

                 // construct from deg, min, sec, and string dirs N,S and E,W
        Position (long& latdeg, long& latmin, long& latsec, char *latdir,
                  long& londeg, long& lonmin, long& lonsec, char *londir);

                 // construct from deg, min, sec, where S and W are negative
        Position (long& latdeg, long& latmin, long& latsec,
                  long& londeg, long& lonmin, long& lonsec);

                 // copy constructor
        Position (Position& pos);


 // set lat or lon functions - follow above schemes

void    SetLat (long lat);
void    SetLat (long& deg, long& min, long& sec, char *dir);
void    SetLat (long& deg, long& min, long& sec);

void    SetLon (long lon);
void    SetLon (long& deg, long& min, long& sec, char *dir);
void    SetLon (long& deg, long& min, long& sec);

void    SetLatLon (long lat, long lon);

// accessing functions

// formats a 24 byte char far string: N 75 34 22  E 123 43 22

void     FormatPosition (char* line, unsigned int maxlen);

// converts lat, lon into deg, min, sec and string directions

void    PositionToLong (long& latdeg, long& latmin, long& latsec, char *latdir,
                        long& londeg, long& lonmin, long& lonsec, char *londir);

Position&  operator= (Position& pos);
};
