#pragma once

// more convenient font type IDs
#define TRUETYPE_FONT 1
#define RASTER_FONT   2
#define DEVICE_FONT   4
#define VECTOR_FONT   8

/***************************************************************************/
/*                                                                         */
/* FrameWin Class Definition                                               */
/*                                                                         */
/***************************************************************************/

class FrameWin : public CFrameWnd {

 /***************************************************************************/
 /*                                                                         */
 /* Class Data Members                                                      */
 /*                                                                         */
 /***************************************************************************/

protected:

LOGFONT*   ptrlogfont;      // user selected font from the common dialog box

CPtrArray  device_fonts;    // containers for the enumerated LOGFONTs
CPtrArray  raster_fonts;
CPtrArray  truetype_fonts;
CPtrArray  vector_fonts;
CPtrArray  oem_fonts;

CListBox  *ptrttlistbox;    // a listbox for the TrueType fonts

int        avg_caps_width;  // average capital letter width
int        avg_char_width;  // average character width
int        avg_char_height; // average character height

 /***************************************************************************/
 /*                                                                         */
 /* Class Functions:                                                        */
 /*                                                                         */
 /***************************************************************************/

public:
              FrameWin (CWnd*, const char*); // constructor

protected:

afx_msg int   OnCreate (LPCREATESTRUCT);     // enumerate fonts; fill list box
afx_msg void  OnPaint ();                    // display enumerated fonts
afx_msg void  OnClose ();                    // determines if app can quit yet
afx_msg void  OnSize (UINT, int, int);       // position the TrueType List Box
afx_msg void  OnDestroy ();                  // 4 containers and list box

// call back functions
static BOOL CALLBACK AFX_EXPORT  EnumPrinterFonts (ENUMLOGFONT*,
                                              NEWTEXTMETRICEX*, int, LPVOID);

// utility functions
int           DisplayMsg (int, int, UINT);   // displays a message box
void          AddFontToList (ENUMLOGFONT*, int); // adds to queue and list box
void          GetAvgCharDims (CDC&);         // get avg char dims for display

// command processors
afx_msg void  CmExit ();                     // post a quit message
afx_msg void  CmFontChange ();               // Choose Font Common Dialog
afx_msg void  CmHelpAbout ();                // help about our app

DECLARE_MESSAGE_MAP()
};
