#include "stdafx.h"
#include "Pgm14b.h"
#include "ListBoxLinesPP.h"
#include "MainFrm.h"

IMPLEMENT_DYNAMIC(ListBoxLinesPP, CPropertyPage)

ListBoxLinesPP::ListBoxLinesPP (MainFrame* ptrfrm)
	             : CPropertyPage(ListBoxLinesPP::IDD) {
 ptrframe = ptrfrm;
}

ListBoxLinesPP::~ListBoxLinesPP() { }

/***************************************************************************/
/*                                                                         */
/*  ListBoxLinesPP::OnInitDialog: fill up the list box                     */
/*                                                                         */
/***************************************************************************/

BOOL  ListBoxLinesPP::OnInitDialog () {
 // obtain a pointer to the existing listbox
 CListBox *ptrlistbox = (CListBox*) (GetDlgItem (IDC_LISTBOX));

 // fill up list box from parent's line array
 for (int i=0; i<ptrframe->linetot; i++) {
  ptrlistbox->AddString (ptrframe->line[i]);  // insert lines into dlg
  if (i+3 == ptrframe->linenum) ptrlistbox->SetCurSel (i);
 }
 return TRUE;
}

BEGIN_MESSAGE_MAP(ListBoxLinesPP, CPropertyPage)
 ON_COMMAND(IDOK, OnOK)
 ON_LBN_SELCHANGE(IDC_LISTBOX, &ListBoxLinesPP::OnLbnSelchangeListbox)
END_MESSAGE_MAP()

/***************************************************************************/
/*                                                                         */
/*  ListBoxLinesPP::OnOK: notify parent of the selected index number       */
/*                                                                         */
/***************************************************************************/

void   ListBoxLinesPP::OnOK () {
 // get a ptr to the listbox control itself
 CListBox *ptrlistbox = (CListBox*) (GetDlgItem (IDC_LISTBOX));
 // save the current user selection index
 ptrframe->linenumnew = ptrlistbox->GetCurSel ();
 CPropertyPage::OnOK (); // invoke base class to destroy
}

/***************************************************************************/
/*                                                                         */
/*  ListBoxLinesPP::OnKillActive: notify parent of sel index number        */
/*                                                                         */
/* Note: needed because OnOK is not called when OK is pressed if this page */
/*       is not the current visible page in the Sheet                      */
/*                                                                         */
/***************************************************************************/

BOOL  ListBoxLinesPP::OnKillActive () {
 // get a ptr to the listbox control itself
 CListBox *ptrlistbox = (CListBox*) (GetDlgItem (IDC_LISTBOX));

  // save the current user selection index
 ptrframe->linenumnew = ptrlistbox->GetCurSel ();

 return CPropertyPage::OnKillActive (); // invoke base class to destroy
}

void ListBoxLinesPP::OnLbnSelchangeListbox() {
 SetModified (TRUE);
}

BOOL ListBoxLinesPP::OnApply() {
 // get a ptr to the listbox control itself
 CListBox *ptrlistbox = (CListBox*) (GetDlgItem (IDC_LISTBOX));
 // save the current user selection index
 ptrframe->linenumnew = ptrlistbox->GetCurSel ();
 ptrframe->Invalidate ();
 return CPropertyPage::OnApply();
}
