#include "stdafx.h"
#include "Pgm14b.h"
#include "LocateDlg.h"
#include "MainFrm.h"

IMPLEMENT_DYNAMIC(LocateDlg, CDialog)

LocateDlg::LocateDlg (CWnd *pParent)
	         : CDialog(LocateDlg::IDD, pParent) {
 Create (IDD_MODELESS, pParent); // modeless dlgs must be created
}

LocateDlg::~LocateDlg() { }

/***************************************************************************/
/*                                                                         */
/* CLocateDlg::DestroyWindow: activated when user closes modeless dialog   */
/*                                                                         */
/* we need to alter parent's tracking on indicator to false or off         */
/*                                                                         */
/***************************************************************************/

BOOL LocateDlg::DestroyWindow () {
 // gain access to a pointer to the track_on public member
 // MainFrame *ptrparent = (MainFrame*) AfxGetApp()->m_pMainWnd;
 MainFrame *ptrparent = (MainFrame*) (GetParent ());

  // set parent's public tracking indicator off to cease sending us position msg
 ptrparent-> track_on = false;
 return CDialog::DestroyWindow ();
}

/***************************************************************************/
/*                                                                         */
/*  LocateDlg::OnCancel: handle ESC and closing by calling DestroyWindows  */
/*                                                                         */
/* because default handler does not delete the modeless dlg box, just hides*/
/*                                                                         */
/***************************************************************************/

void LocateDlg::OnCancel () {
 DestroyWindow();  // modeless dlgs must be destroyed
}

/***************************************************************************/
/*                                                                         */
/*  LocateDlg::ShowPos: updates the static x,y mouse position fields in box*/
/*                                                                         */
/***************************************************************************/
            
void LocateDlg::ShowPos (CPoint &pt) {
 char x[5];
 char y[5];
 _itoa_s (pt.x, x, sizeof(x), 10);
 _itoa_s (pt.y, y, sizeof(x), 10);
 SetDlgItemText (IDC_CURSOR_X, x);
 SetDlgItemText (IDC_CURSOR_Y, y);
}

BEGIN_MESSAGE_MAP(LocateDlg, CDialog)
END_MESSAGE_MAP()
