#pragma once

#include "TransferNames.h"
class LocateDlg;
class MainFrame : public CFrameWnd {

 /***************************************************************************/
 /*                                                                         */
 /* Class Data Members                                                      */
 /*                                                                         */
 /***************************************************************************/

public:
// transfer areas to/from dialogs - need to be public so they can be accessed
//                                  from dialogs without using globals

 // accessed by location dlg directly
bool            track_on;    // when true, displays mouse coordinates

// accessed by edit names dlg directly
TRANSFER_NAMES  xfer_edit_names;  // edit names transfer buffer

// place to store current index of which radio btn is on - not accessed by dlg
int  which_cursor; // radio button xfer buffer = index of which btn is on

// place to store current checkbox statuses - not accessed by dlg
int  show_name;   // show names when TRUE - for checkboxes
int  show_cursor; // show cursor when TRUE

// members accessed by listbox dlg
char line[50][10];// lines for listbox
int  linetot;     // total lines in array that are used
int  linenumnew;  // set by CmOk
int  linenum;     // current line number to show names on

protected:
CSliderCtrl     slider;      // slider control to adjust display line
CEdit           editctl;     // the buddy edit box for the spin control
CSpinButtonCtrl spinctl;     // up/down spin button for setting dsply line

int             height;      // current client window height in pixels
int             width;       // current client window width in pixels

int             avg_caps_width;  // average capital letter width
int             avg_char_width;  // average character width
int             avg_char_height; // average character height

HCURSOR         hcursor;         // current cursor in use
HBRUSH          hbkgrndbrush;    // current background brush
LocateDlg      *ptrlocatedlg;    // ptr to the LocateDlg modeless dialog
TRANSFER_NAMES  real_names_db;   // real data base - first and last name

 /***************************************************************************/
 /*                                                                         */
 /* Class Functions:                                                        */
 /*                                                                         */
 /***************************************************************************/

 public:
              MainFrame (const char* title); // constructor
             ~MainFrame () {}                 // destructor

protected:

afx_msg void  OnPaint ();                    // paint the window - WM_PAINT
afx_msg int   OnCreate (LPCREATESTRUCT);     // set initial class members
afx_msg void  OnDestroy ();                  // delete inited class members
afx_msg void  OnClose ();                    // determines if app can quit yet
afx_msg void  OnSize (UINT, int, int);       // process window resize
afx_msg void  OnMouseMove (UINT, CPoint);    // track current position
afx_msg void  OnSpinChange ();               // respond to spin control
afx_msg void  OnHScroll(UINT, UINT, CScrollBar*); // respond to slider events
afx_msg void  CmPropertySheet ();            // start tabbed dialog box
afx_msg void  CmLocationDlg ();              // start cursor location dialog

public:
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif
	DECLARE_MESSAGE_MAP()
};
