#include "stdafx.h"
#include "Pgm14b.h"
#include "NamesPP.h"

IMPLEMENT_DYNAMIC(NamesPP, CPropertyPage)

NamesPP::NamesPP (TRANSFER_NAMES *ptrnam) : CPropertyPage(NamesPP::IDD) {
 ptrparentbuf = ptrnam;
}

NamesPP::~NamesPP() { }

BEGIN_MESSAGE_MAP(NamesPP, CPropertyPage)
 ON_BN_CLICKED(IDC_CLEARBUTTON, &NamesPP::OnClear)
 ON_BN_CLICKED(IDC_RESETBUTTON, &NamesPP::OnReset)
 ON_EN_CHANGE(IDC_FIRSTNAME, &NamesPP::OnEnChangeFirstname)
 ON_EN_CHANGE(IDC_LASTNAME, &NamesPP::OnEnChangeLastname)
END_MESSAGE_MAP()

/***************************************************************************/
/*                                                                         */
/*  NamesPP::OnInitDialog: loads xfer buffer,save area in case of restore  */
/*                          and loads in init values for edit controls     */
/*                                                                         */
/***************************************************************************/

BOOL      NamesPP::OnInitDialog () {
 // copy the original contents of the xfer buffer to dlg's save area  
 memcpy (&original_names, ptrparentbuf, sizeof (TRANSFER_NAMES));

 // copy original contents into the dlg controls
 SetDlgItemText (IDC_FIRSTNAME, original_names.first_name);
 SetDlgItemText (IDC_LASTNAME,  original_names.last_name);
 return TRUE;
}

/***************************************************************************/
/*                                                                         */
/*  NamesPP::CmClear: remove contents of both fields, appears blank        */
/*                                                                         */
/***************************************************************************/

void NamesPP::OnClear() {
 // clear transfer buffer - set to nulls
 memset (ptrparentbuf, 0, sizeof (TRANSFER_NAMES));
 // clear dlg controls
 SetDlgItemText (IDC_FIRSTNAME, ptrparentbuf->first_name);
 SetDlgItemText (IDC_LASTNAME,  ptrparentbuf->last_name);
}

/***************************************************************************/
/*                                                                         */
/*  NamesPP::CmReset: reinsert the original values into the name fields    */
/*                                                                         */
/***************************************************************************/

void NamesPP::OnReset() {
 // copy saved original values back into the transfer buffer
 memcpy (ptrparentbuf, &original_names, sizeof (TRANSFER_NAMES));
 // copy saved original values back into the edit controls boxes
 SetDlgItemText (IDC_FIRSTNAME, original_names.first_name);
 SetDlgItemText (IDC_LASTNAME,  original_names.last_name);
}

/***************************************************************************/
/*                                                                         */
/*  NamesPP::OnOk: retrieve new values                                     */
/*                                                                         */
/***************************************************************************/

void NamesPP::OnOK () {
 // retrieve new values from edit controls and store in parent's xfer buffer
 GetDlgItemText (IDC_FIRSTNAME, ptrparentbuf->first_name, MAX_NAME_LEN);
 GetDlgItemText (IDC_LASTNAME,  ptrparentbuf->last_name, MAX_NAME_LEN);
 CPropertyPage::OnOK ();  // now continue the Ok process
}

/***************************************************************************/
/*                                                                         */
/* CNamesPP::OnKillActive: retrieve new values                             */
/*                                                                         */
/***************************************************************************/

BOOL NamesPP::OnKillActive () {
 // retrieve new values from edit controls and store in parent's xfer buffer
 GetDlgItemText (IDC_FIRSTNAME, ptrparentbuf->first_name, MAX_NAME_LEN);
 GetDlgItemText (IDC_LASTNAME,  ptrparentbuf->last_name, MAX_NAME_LEN);
 return CPropertyPage::OnKillActive ();  // now continue the Ok process
}

/***************************************************************************/
/*                                                                         */
/*  NamesPP::OnCancel: restore the original values into  transfer buffer   */
/*                                                                         */
/***************************************************************************/

void NamesPP::OnCancel () {
 // restore original values into the parent's transfer buffer
 memcpy (ptrparentbuf, &original_names, sizeof (TRANSFER_NAMES));
 CPropertyPage::OnCancel ();  // now continue the cancel process
}

void NamesPP::OnEnChangeFirstname() {
 SetModified (TRUE);
}

void NamesPP::OnEnChangeLastname() {
 SetModified (TRUE);
}

BOOL NamesPP::OnApply() {
 // retrieve new values from edit controls and store in parent's xfer buffer
 GetDlgItemText (IDC_FIRSTNAME, ptrparentbuf->first_name, MAX_NAME_LEN);
 GetDlgItemText (IDC_LASTNAME,  ptrparentbuf->last_name, MAX_NAME_LEN);
 GetParent()->Invalidate ();
 return CPropertyPage::OnApply();
}
